=== modified file 'source/addonHandler.py'
--- source/addonHandler.py	2012-07-25 09:56:50 +0000
+++ source/addonHandler.py	2012-07-27 02:13:35 +0000
@@ -365,24 +365,11 @@
 		@param addonPath: Path where to extract contents.
 		@type addonPath: string
 		"""
-		log.debug("Extracting add-on %s to %s", self._manifest['name'], addonPath)
 		with zipfile.ZipFile(self._path, 'r') as z:
-			# As python's zipfile module doesn't handle unicode file names
-			# Manually extract the zipfile contencts with the proper decoded name.
-			# Use UTF-8 if the EFS flag is set, else use the local OEM code page.
-			# See discussion in #2505 for details.
-			for entry in z.infolist():
-				codec = "utf-8" if entry.flag_bits & 0x800 else str(winKernel.kernel32.GetOEMCP())
-				fsPath = os.path.join(addonPath, unicode(entry.filename, codec))
-				log.debug("Writing file %s", fsPath)
-				dir = os.path.dirname(fsPath)
-				try:
-					os.makedirs(dir)
-				except OSError:
-					pass
-				with z.open(entry) as src:
-					with open(fsPath, 'wb') as dest:
-						shutil.copyfileobj(src, dest)
+			for info in z.infolist():
+				if isinstance(info.filename, str):
+					info.filename = info.filename.decode(str(winKernel.kernel32.GetOEMCP()))
+				z.extract(info, addonPath)
 
 	@property
 	def manifest(self):

